/**
 * View page module
 *
 * @module     mod_interactivevideo/viewannotation
 * @copyright  2024 Sokunthearith Makara <sokunthearithmakara@gmail.com>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 */
define("mod_interactivevideo/viewannotation",["jquery","core/event_dispatcher","core/toast","mod_interactivevideo/libraries/jquery-ui"],(function($,eventDispatcher,Toast){const{dispatchEvent:dispatchEvent}=eventDispatcher,ctRenderer={};let annotations,totaltime,activityType,contentTypes,displayoptions,releventAnnotations,completionid,player,lastrun,viewedAnno=[];const $videoNav=$("#video-nav"),$interactionNav=$("#interactions-nav"),$loader=$("#background-loading"),renderAnnotationItems=async(annos,start,totaltime)=>{releventAnnotations=annos,window.IVANNO=annos;let actualduration=totaltime;const skipsegments=annos.filter((x=>"skipsegment"==x.type));skipsegments.length>0&&skipsegments.forEach((x=>{const length=Number(x.title)-Number(x.timestamp);actualduration-=length}));const completableAnno=releventAnnotations.filter((x=>1==x.hascompletion)),actualAnnotationCounts=completableAnno.length,xp=completableAnno.map((x=>Number(x.xp))).reduce(((a,b)=>a+b),0),completedAnnos=completableAnno.filter((x=>x.completed)),xpEarned=completedAnnos.map((x=>Number(x.earned))).reduce(((a,b)=>a+b),0);if($(".metadata").empty(),$(".metadata").append('<span class="d-inline-block mr-3">\n            <i class="bi bi-stopwatch mr-2"></i>'.concat((seconds=>{const hours=Math.floor(seconds/3600),minutes=Math.floor(seconds%3600/60),remainingSeconds=seconds%60;let string="";return hours>0&&(string+=hours+"h "),minutes>0&&(string+=minutes+"m "),remainingSeconds>0&&(string+=remainingSeconds+"s"),string})(Math.ceil(actualduration)),'</span>\n            <span class="d-inline-block mr-3">\n        <i class="bi bi-bullseye mr-2"></i>').concat(completedAnnos.length," / ").concat(actualAnnotationCounts,'</span>\n        <span class="d-inline-block"><i class="bi bi-star mr-2"></i>').concat(xpEarned," / ").concat(xp,"</span>")),$("#interactions-nav ul").empty(),1==displayoptions.preventseeking&&$videoNav.addClass("no-pointer-events"),1==displayoptions.hidemainvideocontrols||1==displayoptions.hideinteractions)return 1==displayoptions.hidemainvideocontrols&&$("#wrapper").addClass("no-videonav"),void dispatchEvent("annotationitemsrendered",{annotations:annos,completed:completedAnnos.length,total:actualAnnotationCounts,xp:xpEarned,totalxp:xp});for(const x of annos){const renderer=ctRenderer[x.type];await renderer.renderItemOnVideoNavigation(x)}dispatchEvent("annotationitemsrendered",{annotations:annos,completed:completedAnnos.length,total:actualAnnotationCounts,xp:xpEarned,totalxp:xp}),$(".annolistinchapter").empty();const chapteritems=releventAnnotations.filter((x=>"skipsegment"!=x.type&&1==x.hascompletion));chapteritems.sort(((a,b)=>a.timestamp-b.timestamp)),chapteritems.forEach((x=>{$('[data-region="chapterlists"] li').each((function(){const cstart=$(this).data("start"),cend=$(this).data("end");x.timestamp>=cstart&&x.timestamp<cend&&$(this).find(".annolistinchapter").append('<li class="border-bottom anno d-flex align-items-center justify-content-between\n                         px-3 py-2 '.concat(x.completed?"completed":"",'" data-id="').concat(x.id,'" data-timestamp="').concat(x.timestamp,'">\n                         <span class="text-nowrap">\n                         <i class="small bi ').concat(x.completed?"bi-check-circle-fill text-success":"bi-circle",' mr-2"></i>\n                         <i class="').concat(JSON.parse(x.prop).icon,' mr-2"></i></span>\n                         <span class="flex-grow-1 text-truncate">').concat(x.formattedtitle,'</span>\n                         <span class="text-nowrap">').concat(x.xp,'<i class="bi bi-star ml-1"></i></span></li>'))}))})),dispatchEvent("chapterrendered",{annotations:releventAnnotations})};return{renderAnnotationItems:renderAnnotationItems,init:function(url,cmid,interaction,course,userid){let start=arguments.length>5&&void 0!==arguments[5]?arguments[5]:0,end=arguments.length>6?arguments[6]:void 0,completionpercentage=arguments.length>7?arguments[7]:void 0,gradeiteminstance=arguments.length>8?arguments[8]:void 0,grademax=arguments.length>9?arguments[9]:void 0,vtype=arguments.length>10?arguments[10]:void 0,preventskip=!(arguments.length>11&&void 0!==arguments[11])||arguments[11],moment=arguments.length>12&&void 0!==arguments[12]?arguments[12]:null,doptions=arguments.length>13&&void 0!==arguments[13]?arguments[13]:{},token=arguments.length>14&&void 0!==arguments[14]?arguments[14]:null,extendedcompletion=arguments.length>15&&void 0!==arguments[15]?arguments[15]:null;start=Number(start),isNaN(start)&&(start=0),end=Number(end),isNaN(end)&&(end=null),displayoptions=doptions;let playerReady=!1;"true"==localStorage.getItem("limitedwidth")&&0==displayoptions.hidemainvideocontrols&&($("body").addClass("limited-width"),$("#controller #expand i").removeClass("bi-file").addClass("bi-square"));const convertSecondsToHMS=seconds=>{if(seconds<0)return"00:00";const h=Math.floor(seconds/3600),m=Math.floor(seconds%3600/60),s=Math.floor(seconds%3600%60);return(h>0?h+":":"")+(m<10?"0":"")+m+":"+(s<10?"0":"")+s},replaceProgressBars=percentage=>new Promise((resolve=>{percentage=percentage>100?100:percentage,$videoNav.find("#progress").css("width",percentage+"%"),$videoNav.find("#seekhead").css("left",percentage+"%"),resolve(!0)})),getAnnotations=callback=>{const annnoitems=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_items",sesskey:M.cfg.sesskey,id:interaction,contextid:M.cfg.courseContextId,token:token,cmid:cmid}}),userprogress=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_progress",sesskey:M.cfg.sesskey,id:interaction,uid:userid,token:token,cmid:cmid,contextid:M.cfg.contextid,previewmode:$("body").hasClass("preview-mode")?1:0}}),getContentTypes=$.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"get_all_contenttypes",sesskey:M.cfg.sesskey,token:token,cmid:cmid,contextid:M.cfg.contextid}});$.when(annnoitems,userprogress,getContentTypes).done((async function(annos,progress,ct){annotations=JSON.parse(annos[0]),progress=JSON.parse(progress[0]),contentTypes=JSON.parse(ct[0]),completionid=progress.id;let completiondetails=JSON.parse(progress.completiondetails||"[]");return annotations=function(annotations,contentTypes,start,end){return annotations.filter((annotation=>!!contentTypes.some((y=>y.name===annotation.type))&&("skipsegment"===annotation.type?!(annotation.timestamp>end||annotation.title<start):annotation.timestamp>=start&&annotation.timestamp<=end||annotation.timestamp<0)))}(annotations,contentTypes,start,end),annotations=function(annotations,contentTypes,progress,start,end,completiondetails){const completedItems=""==progress.completeditems?[]:JSON.parse(progress.completeditems),contentTypeMap=new Map(contentTypes.map((ct=>[ct.name,ct])));return annotations.map((annotation=>{annotation.timestamp=Number(annotation.timestamp),annotation.xp=Number(annotation.xp);const completionitem=completiondetails.find((x=>JSON.parse(x).id==annotation.id));let advanced;annotation.earned=completionitem?Number(JSON.parse(completionitem).xp):0,"skipsegment"==annotation.type&&(annotation.title=Number(annotation.title),annotation.timestamp<start&&annotation.title>start&&(annotation.timestamp=start),annotation.title>end&&annotation.timestamp<end&&(annotation.title=end)),annotation.prop=JSON.stringify(contentTypeMap.get(annotation.type)),annotation.completed=completedItems.indexOf(annotation.id)>-1;try{advanced=JSON.parse(annotation.advanced)}catch(e){advanced=null}return annotation.rerunnable=advanced&&"1"===advanced.replaybehavior,annotation}))}(annotations,contentTypes,progress,start,end,completiondetails),annotations.sort(((a,b)=>a.timestamp-b.timestamp)),releventAnnotations=function(annotations){const skipsegments=annotations.filter((annotation=>"skipsegment"==annotation.type));let releventAnnotations=[];return annotations.forEach((annotation=>{let shouldAdd=!0;skipsegments.forEach((skipsegment=>{Number(annotation.timestamp)>Number(skipsegment.timestamp)&&Number(annotation.timestamp)<Number(skipsegment.title)&&(shouldAdd=!1)})),shouldAdd&&releventAnnotations.push(annotation)})),releventAnnotations}(annotations),releventAnnotations.length>0&&!releventAnnotations.find((x=>"chapter"==x.type))&&function(releventAnnotations,start,contentTypes){releventAnnotations.unshift({id:0,title:M.util.get_string("startchapter","mod_interactivevideo"),formattedtitle:M.util.get_string("startchapter","mod_interactivevideo"),timestamp:start,type:"chapter",prop:JSON.stringify(contentTypes.find((x=>"chapter"==x.name))),xp:0,completed:!0,hide:!0})}(releventAnnotations,start,contentTypes),await async function(contentTypes,releventAnnotations,player,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,cmid,token,completionid){const chapterContentType=contentTypes.find((x=>"chapter"==x.name));if(0==(contentTypes=contentTypes.filter((x=>releventAnnotations.map((y=>y.type)).includes(x.name)))).length)return void $("#chaptertoggle, #chapter-container-left, #chapter-container-right").remove();$("#chaptertoggle, #chapter-container-left, #chapter-container-right").removeClass("d-none");contentTypes.find((x=>"chapter"==x.name))||contentTypes.push(chapterContentType);await Promise.all(contentTypes.map((contentType=>new Promise((resolve=>{require([contentType.amdmodule],(function(Type){ctRenderer[contentType.name]=new Type(player,releventAnnotations,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,contentType,cmid,token,displayoptions,completionid,extendedcompletion);try{ctRenderer[contentType.name].init()}catch(error){}resolve()}))})))))}(contentTypes,releventAnnotations,player,interaction,course,userid,completionpercentage,gradeiteminstance,grademax,vtype,preventskip,totaltime,start,end,cmid,token,completionid),await renderAnnotationItems(releventAnnotations,0,totaltime),$("#play").removeClass("d-none"),$("#spinner").remove(),$("#video-info").toggleClass("d-none d-flex"),playerReady=!0,callback(),new Promise((resolve=>{resolve()}))}))},runInteraction=async annotation=>{if(lastrun=annotation.id,$("#video-wrapper").data("timestamp",(new Date).getTime()),viewedAnno.push(Number(annotation.id)),viewedAnno=[...new Set(viewedAnno)],$("#annotation-modal").modal("hide"),$("#message").not("[data-placement=bottom]").not(".sticky").not("[data-id=".concat(annotation.id,"]")).remove(),$("#end-screen, #start-screen").fadeOut(300),preventskip){const theAnnotations=releventAnnotations.filter((x=>Number(x.timestamp)<Number(annotation.timestamp)&&0==x.completed&&1==x.hascompletion));if(theAnnotations.length>0){const theAnnotation=theAnnotations[0];return await player.pause(),await player.seek(theAnnotation.timestamp-.7>start?theAnnotation.timestamp-.7:start),void Toast.add(M.util.get_string("youmustcompletethepreviousactivity","mod_interactivevideo"),{type:"danger"})}}activityType=ctRenderer[annotation.type],activityType.runInteraction(annotation),dispatchEvent("interactionrun",{annotation:annotation})},shareMoment=async()=>{if(!moment)return;const urlParams=new URLSearchParams(window.location.search),time=Number(moment);time&&!isNaN(time)&&time>=start&&time<=end&&($("#video-wrapper #start-screen").hide(0),await replaceProgressBars((time-start)/totaltime*100),await player.seek(time),player.play()),urlParams.delete("t");const newurl=window.location.protocol+"//"+window.location.host+window.location.pathname+"?"+urlParams.toString();window.history.replaceState(null,null,newurl)},updateTime=async duration=>{let toUpdatetime=!1;return(!end||0==end||end>duration)&&(toUpdatetime=!0),end=end?Math.min(end,duration):duration,(!start||start>=duration||start<0||start>=end)&&(toUpdatetime=!0),start=start>end?0:start,toUpdatetime&&await $.ajax({url:M.cfg.wwwroot+"/mod/interactivevideo/ajax.php",method:"POST",dataType:"text",data:{action:"update_videotime",sesskey:M.cfg.sesskey,id:interaction,start:start,end:end,contextid:M.cfg.contextid}}),{start:start,end:end}};let loaded=!1;const onLoaded=async()=>{loaded=!0,window.IVPLAYER=player,0==player.support.playbackrate?$("#changerate").remove():$("#changerate").removeClass("d-none"),0==player.support.quality?$("#changequality").remove():$("#changequality").removeClass("d-none");const duration=player.totaltime;({start:start,end:end}=await updateTime(duration)),totaltime=end-start,$("#duration").text(convertSecondsToHMS(totaltime));let ratio=16/9;displayoptions.usefixedratio&&0!=displayoptions.usefixedratio||(ratio=player.aspectratio),$("#video-wrapper").css("padding-bottom",1/ratio*100+"%");let gap="125px";$("body").hasClass("embed-mode")?1==displayoptions.hidemainvideocontrols?$("#wrapper").css({width:"calc(100dvh * "+ratio+")"}):$("#wrapper").css({width:"calc((100dvh - 55px) * "+ratio+")"}):(1==displayoptions.hidemainvideocontrols&&(gap="55px"),$("#wrapper").css({width:"calc((100dvh - "+gap+" - 2rem) * "+ratio+")"})),$("#wrapper").attr("data-ratio",ratio),$("#wrapper").attr("data-gap",gap),$("#start-screen #start").focus(),$("#seekhead").draggable({containment:"#video-nav",axis:"x",cursor:"col-resize",start:function(event,ui){$(this).addClass("active"),$("#taskinfo").addClass("no-pointer-events"),$("#message, #end-screen").remove(),$("#seek").append('<div id="position"><div id="timelabel"></div></div>');let $position=$("#position");const relX=ui.position.left;$position.css("left",relX+"px");const percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$position.find("#timelabel").text(formattedTime)},drag:async function(event,ui){let timestamp=ui.position.left/$("#video-nav").width()*totaltime+start,percentage=ui.position.left/$("#video-nav").width();await replaceProgressBars(100*percentage),$("#seek #position").css("left",ui.position.left+"px"),$("#seek #position #timelabel").text(convertSecondsToHMS(timestamp-start)),await player.seek(timestamp),await player.pause()},stop:async function(){setTimeout((function(){$("#taskinfo").removeClass("no-pointer-events")}),200),setTimeout((function(){$("#seekhead").removeClass("active"),$("#seek #position").remove()}),1e3),player.play()}});let vwrapper=document.querySelector("#video-wrapper");new ResizeObserver((()=>{vwrapper.clientWidth>1050?$("#controller #expand").removeClass("d-none"):$("#controller #expand").addClass("d-none")})).observe(vwrapper),$("body").hasClass("embed-mode")||vwrapper.scrollIntoView({behavior:"smooth",block:"end",inline:"nearest"})},onReady=async()=>{if(loaded||onLoaded(),!moment){const lastwatched=localStorage.getItem("watchedpoint-".concat(userid,"-").concat(interaction));lastwatched&&(lastwatched>start+60||lastwatched<end-60)&&player.seek(lastwatched)}$(".video-block").css("background","transparent"),$("#annotation-canvas").removeClass("d-none"),await getAnnotations(shareMoment),dispatchEvent("timeupdate",{time:start})},onPaused=async()=>{playerReady&&($("#playpause").find("i").removeClass("bi-pause-fill").addClass("bi-play-fill"),$("#playpause").attr("data-original-title",M.util.get_string("play","mod_interactivevideo")),localStorage.setItem("watchedpoint-".concat(userid,"-").concat(interaction),await player.getCurrentTime()))},onEnded=async()=>{playerReady&&($("#currenttime").text(convertSecondsToHMS(totaltime)),$("#restart").removeClass("d-none").fadeIn(300),$("#end-screen").removeClass("d-none").fadeIn(300),$("#progress").css("width","100%"),$("#seekhead").css("left","100%"),await player.pause(),dispatchEvent("timeupdate",{time:end}),$("#playpause").find("i").removeClass("bi-pause-fill").addClass("bi-play-fill"),$("#playpause").attr("data-original-title",M.util.get_string("play","mod_interactivevideo")),dispatchEvent("ended",{time:end}),localStorage.removeItem("watchedpoint-".concat(userid,"-").concat(interaction)))},onSeek=async t=>{if(!playerReady)return;(t=t?Number(t):await player.getCurrentTime())>start&&t<end&&$("#end-screen, #start-screen").addClass("d-none");const percentage=(t-start)/totaltime*100;$("#currenttime").text(convertSecondsToHMS(t-start)),replaceProgressBars(percentage),dispatchEvent("timeupdate",{time:t})};let visualized=!1;const onPlaying=()=>{if(!playerReady)return;player.audio&&!visualized&&(player.visualizer(),visualized=!0),$("body").hasClass("mobiletheme")&&!$("#wrapper").hasClass("fullscreen")&&$("#fullscreen").trigger("click"),$("#annotation-modal").modal("hide"),$("#message").not("[data-placement=bottom]").not(".sticky").remove(),$("#end-screen, #start-screen").fadeOut(300),$("#restart").addClass("d-none"),$("#playpause").find("i").removeClass("bi-play-fill").addClass("bi-pause-fill"),$("#playpause").attr("data-original-title",M.util.get_string("pause","mod_interactivevideo"));const intervalFunction=async function(){const t=await player.getCurrentTime();viewedAnno=viewedAnno.filter((x=>releventAnnotations.find((y=>y.id==x)).timestamp<=t));const isPlaying=await player.isPlaying(),isEnded=await player.isEnded();if(!isPlaying||isEnded)return;if(t>end||isEnded)return void onEnded(end);$("#mute i").hasClass("bi-volume-up")&&"wistia"==player.type&&player.unMute(),dispatchEvent("timeupdate",{time:t});const time=Number(t.toFixed(2));let percentagePlayed=(t-start)/totaltime;$("#currenttime").text(convertSecondsToHMS(t-start)),percentagePlayed=percentagePlayed>1?1:percentagePlayed,$("#video-nav #progress").css("width",100*percentagePlayed+"%"),$("#video-nav #seekhead").css("left",100*percentagePlayed+"%");const theAnnotation=releventAnnotations.find((x=>((t-.5).toFixed(2)<=x.timestamp&&(t+player.frequency).toFixed(2)>=x.timestamp||time==x.timestamp)&&0!=x.id&&!viewedAnno.includes(Number(x.id))));if(theAnnotation){if($('#interactions-nav .annotation[data-id="'+theAnnotation.id+'"] .item').trigger("mouseover").addClass("active"),setTimeout((function(){$('#interactions-nav .annotation[data-id="'+theAnnotation.id+'"] .item').trigger("mouseout").removeClass("active")}),2e3),lastrun&&theAnnotation.id==lastrun)return;if($("body").hasClass("preview-mode"))return;theAnnotation.completed&&!theAnnotation.rerunnable||($("#video-nav #progress").css("width",(theAnnotation.timestamp-start)/totaltime*100+"%"),$("#video-nav #seekhead").css("left",(theAnnotation.timestamp-start)/totaltime*100+"%"),await player.seek(theAnnotation.timestamp),runInteraction(theAnnotation))}};if("yt"==player.type||"wistia"==player.type){const animate=async()=>{intervalFunction(),await player.isPlaying()&&requestAnimationFrame(animate)};requestAnimationFrame(animate)}else intervalFunction()};require(["mod_interactivevideo/player/"+vtype],(function(VideoPlayer){player=new VideoPlayer(url,start,end,{showControls:1==displayoptions.useoriginalvideocontrols,customStart:!0,preload:!1,autoplay:1==displayoptions.autoplay})}));let $toast=$(".toast-wrapper").detach();$("#wrapper").append($toast),$(document).on("timeupdate",(async function(e){const t=e.originalEvent.detail.time;if(preventskip){const theAnnotations=releventAnnotations.filter((x=>Number(x.timestamp)<=t+player.frequency&&0==x.completed&&1==x.hascompletion));if(theAnnotations.length>0){const theAnnotation=theAnnotations[0];await player.pause(),await player.seek(theAnnotation.timestamp-.7>start?theAnnotation.timestamp-.7:start),Toast.add(M.util.get_string("youmustcompletethepreviousactivity","mod_interactivevideo"),{type:"danger"}),$videoNav.find("#progress").css("width",(theAnnotation.timestamp-start)/totaltime*100+"%"),$videoNav.find("#seekhead").css("left",(theAnnotation.timestamp-start)/totaltime*100+"%")}}})),$(document).on("click","#message #refresh",(function(e){e.preventDefault(),e.stopImmediatePropagation();const id=$(this).data("id"),annotation=releventAnnotations.find((x=>x.id==id));$(this).closest("#message").remove(),runInteraction(annotation)})),$(document).on("click","#fullscreen",(function(e){if(e.preventDefault(),!playerReady)return;let elem=document.getElementById("wrapper");$("#fullscreen").toggleClass("active"),$("#wrapper").hasClass("fullscreen")?document.exitFullscreen?document.exitFullscreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.webkitExitFullscreen?document.webkitExitFullscreen():document.msExitFullscreen&&document.msExitFullscreen():elem.requestFullscreen?elem.requestFullscreen():elem.mozRequestFullScreen?elem.mozRequestFullScreen():elem.webkitRequestFullscreen?elem.webkitRequestFullscreen():elem.msRequestFullscreen?elem.msRequestFullscreen():elem.webkitEnterFullscreen?elem.webkitEnterFullscreen():(Toast.add(M.util.get_string("fullscreenisnotsupported","mod_interactivevideo"),{type:"danger"}),$("#fullscreen").remove())})),$(document).on("fullscreenchange",(async function(){if(document.fullscreenElement)$("#wrapper, #interactivevideo-container").addClass("fullscreen"),$("#video-wrapper").css("padding-bottom","0"),$('#wrapper [data-toggle="tooltip"]').tooltip({container:"#wrapper",boundary:"window"});else{$("#wrapper, #interactivevideo-container").removeClass("fullscreen");let ratio=16/9;displayoptions.usefixedratio&&0!=displayoptions.usefixedratio||(ratio=player.aspectratio),$("#video-wrapper").css("padding-bottom",1/ratio*100+"%")}$("#wrapper #fullscreen i").toggleClass("bi-fullscreen bi-fullscreen-exit")})),displayoptions.pauseonblur&&1==displayoptions.pauseonblur&&$(document).on("visibilitychange",(function(){playerReady&&"hidden"==document.visibilityState&&player.pause()})),$(document).on("click","#controller #expand",(function(e){e.preventDefault(),$("body").toggleClass("limited-width"),localStorage.setItem("limitedwidth",$("body").hasClass("limited-width")),$(this).find("i").toggleClass("bi-square bi-file")})),$(document).on("click","#controller #share",(async function(e){e.preventDefault(),e.stopImmediatePropagation();const $this=$(this);$this.find("i").toggleClass("bi-share-fill bi-share");let time=await player.getCurrentTime();const url=window.location.href,shareurl=url+(url.indexOf("?")>0?"&":"?")+"t="+Math.round(time);await navigator.clipboard.writeText(shareurl),$this.attr("data-original-title",M.util.get_string("copied","mod_interactivevideo")).tooltip("show"),setTimeout((function(){$this.attr("data-original-title",M.util.get_string("sharethismoment","mod_interactivevideo")).tooltip("hide"),$this.find("i").toggleClass("bi-share-fill bi-share")}),2e3)})),$(document).on("mouseenter","#video-nav #seek",(function(e){if(!playerReady)return;$(this).append('<div id="position"><div id="timelabel"></div></div>');let $position=$("#position");const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left;$position.css("left",relX+"px");const percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$position.find("#timelabel").text(formattedTime)})),$(document).on("mousemove","#video-nav #seek",(function(e){if(!playerReady)return;const parentOffset=$(this).offset(),relX=e.pageX-parentOffset.left,percentage=relX/$(this).width(),formattedTime=convertSecondsToHMS(percentage*totaltime);$("#position").css("left",relX+"px"),$("#position #timelabel").text(formattedTime)})),$(document).on("mouseleave","#video-nav #seek",(function(){$("#position").remove()})),$(document).on("click","#interactions-nav .annotation, #video-nav .annotation",(async function(e){if(e.preventDefault(),e.stopImmediatePropagation(),$loader.fadeIn(300),$(this).hasClass("no-click"))return void Toast.add(M.util.get_string("youcannotviewthisannotationyet","mod_interactivevideo"),{type:"danger"});const timestamp=$(this).data("timestamp");if(await player.getCurrentTime()==timestamp&&lastrun)return void $loader.fadeOut(300);lastrun=null,player.pause(),await replaceProgressBars((timestamp-start)/totaltime*100),await player.seek(Number(timestamp));const id=$(this).data("id"),theAnnotation=releventAnnotations.find((x=>x.id==id));runInteraction(theAnnotation),$loader.fadeOut(300);const preceedingAnno=releventAnnotations.filter((x=>x.timestamp<timestamp)).map((x=>Number(x.id)));viewedAnno=preceedingAnno,viewedAnno.push(id),viewedAnno=[...new Set(viewedAnno)]})),$(document).on("click","#seek",(async function(e){if(!playerReady)return;if(e.preventDefault(),e.stopImmediatePropagation(),$("#video-nav").hasClass("no-click"))return void Toast.add(M.util.get_string("seekingdisabled","mod_interactivevideo"),{type:"danger"});$("#start-screen").fadeOut(300),$("#end-screen").fadeOut(300);const parentOffset=$(this).offset(),percentage=(e.pageX-parentOffset.left)/$(this).width();await replaceProgressBars(100*percentage),$loader.fadeIn(300),await player.seek(percentage*totaltime+start),player.play(),lastrun=null,setTimeout((()=>{$("#position").remove(),$loader.fadeOut(300)}),300)})),$(document).on("click","#start-screen #play",(async function(e){e.preventDefault(),$("#start-screen").fadeOut(300),$(this).addClass("d-none"),$videoNav.removeClass("d-none"),player.play()})),$(document).on("click","#end-screen #restart",(async function(e){e.preventDefault(),$("#message").remove(),viewedAnno=[],lastrun=null,$loader.fadeIn(300),await player.seek(start),$videoNav.find("#progress").css("width","0%"),$videoNav.find("#seekhead").css("left","0%"),$("#end-screen").fadeOut(300),$(this).addClass("d-none"),$videoNav.removeClass("d-none"),player.play(),$loader.fadeOut(300)})),$(document).on("click","#video-wrapper .video-block",(async function(e){if(!playerReady)return;e.preventDefault();await player.isPlaying()?await player.pause():player.play()})),$(document).on("click","#playpause",(async function(e){if(!playerReady)return;e.preventDefault(),$(this).tooltip("hide");if(await player.isPlaying())await player.pause();else{await player.getCurrentTime()>=end?$("#end-screen #restart").trigger("click"):player.play()}})),$(document).on("click","li.anno",(async function(e){e.preventDefault();const id=$(this).data("id");$("li.annotation[data-id=".concat(id,"]")).trigger("click"),$(this).closest("#chapter-container-left").length>0&&$("#chaptertoggle .btn").trigger("click")})),$(document).on("click","#toolbar #annotation-toggle",(function(e){e.preventDefault(),$("body").addClass("hassidebar"),$("#annotation-sidebar").removeClass("hide")})),$(document).on("click","#mute",(function(e){e.preventDefault(),$(this).tooltip("hide"),$(this).toggleClass("active"),$(this).hasClass("active")?(player.mute(),$(this).attr("data-original-title",M.util.get_string("unmute","mod_interactivevideo"))):(player.unMute(),$(this).attr("data-original-title",M.util.get_string("mute","mod_interactivevideo"))),$(this).find("i").toggleClass("bi-volume-mute bi-volume-up"),$(this).tooltip("show")})),$(document).on("click",".changerate",(function(e){e.preventDefault();const rate=$(this).data("rate");player.setRate(rate),$(".changerate").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")})),$("#changequality").on("shown.bs.dropdown",(async function(){let quality=await player.getQualities();$("#qualitieslist").empty();let currentQuality=quality.currentQuality;null===currentQuality&&(currentQuality=$(this).data("current"));let qualities=quality.qualities,qualitiesLabel=quality.qualitiesLabel;qualities.forEach(((q,i)=>{$("#qualitieslist").append('<a class="dropdown-item text-white changequality" data-quality="'.concat(q,'"\n                         href="#"><i class="bi ').concat(q==currentQuality?"bi-check":"",' fa-fw ml-n3"></i>').concat(qualitiesLabel[i],"</a>"))})),$(this).find("[data-toggle=dropdown]").dropdown("update")})),$(document).on("click",".changequality",(function(e){e.preventDefault();const quality=$(this).data("quality");player.setQuality(quality),$(".changequality").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check")})),$(document).on("click","#changecaption .changecaption",(function(e){e.preventDefault();const lang=$(this).data("lang");player.setCaption(lang),$("#changecaption .changecaption").find("i").removeClass("bi-check"),$(this).find("i").addClass("bi-check"),""==lang?$("#changecaption .btn i").removeClass("bi-badge-cc-fill").addClass("bi-badge-cc"):$("#changecaption .btn i").removeClass("bi-badge-cc").addClass("bi-badge-cc-fill"),localStorage.setItem("caption-".concat(userid),lang)})),$(document).on("iv:playerReady",(function(){onReady()})),$(document).on("iv:playerPaused",(function(){$(".tooltip").remove(),onPaused()})),$(document).on("iv:playerPlaying",(function(){onPlaying(),$loader.fadeOut(300)})),$(document).on("iv:playerEnded",(function(){onEnded()})),$(document).on("iv:playerSeek",(function(e){onSeek(e.detail.time)})),$(document).on("iv:playerLoaded",(function(e){onLoaded(e.detail);const captions=e.detail.tracks;if(!captions||0==captions.length)return;$("#changecaption").removeClass("d-none"),$("#changecaption .dropdown-menu").html('<a class="dropdown-item text-white changecaption"\n                     data-lang="" href="#">\n                     <i class="bi fa-fw bi-check ml-n3"></i>'.concat(M.util.get_string("off","mod_interactivevideo"),"</a>")),captions.forEach((caption=>{$("#changecaption .dropdown-menu").append('<a class="dropdown-item text-white changecaption"\n                         data-lang="'.concat(caption.code,'" href="#"><i class="bi fa-fw ml-n3"></i>').concat(caption.label,"</a>"))}));const lang=localStorage.getItem("caption-".concat(userid));lang&&lang.length&&$('#changecaption .changecaption[data-lang="'+lang+'"]').trigger("click")})),$(document).on("iv:playerError",(function(e){window.console.log(e.detail),Toast.add(M.util.get_string("thereisanissueloadingvideo","mod_interactivevideo"),{type:"danger"}),$("#spinner").remove()})),$(document).on("iv:playerRateChange",(function(e){$(".changerate").find("i").removeClass("bi-check"),$('.changerate[data-rate="'.concat(e.originalEvent.detail.rate,'"]')).find("i").addClass("bi-check")})),$(document).on("iv:playerQualityChange",(function(e){$("#changequality").attr("data-current",e.originalEvent.detail.quality),$(".changequality").find("i").removeClass("bi-check"),$('.changequality[data-quality="'.concat(e.originalEvent.detail.quality,'"]')).find("i").addClass("bi-check")}));let firstPlay=!1;$(document).on("annotationitemsrendered",(function(){$('#wrapper [data-toggle="tooltip"]').tooltip({container:"#wrapper",boundary:"window"}),1==displayoptions.disableinteractionclickuntilcompleted&&$interactionNav.find("li:not(.completed)").addClass("no-click"),1==displayoptions.disableinteractionclick&&$interactionNav.find("li").addClass("no-click"),1==displayoptions.preventseeking&&($interactionNav.find("li").addClass("no-click"),$videoNav.addClass("no-click")),$interactionNav.find("li").length>0&&$("#taskinfo").removeClass("border-0"),1!=displayoptions.autoplay||firstPlay||$("body").hasClass("preview-mode")||setTimeout((function(){$("#play").trigger("click"),player.unMute(),firstPlay=!0}),1e3)})),$("body").hasClass("mobiletheme")&&$('[data-toggle="tooltip"]').on("click",(function(){const $this=$(this);setTimeout((function(){$this.tooltip("hide")}),2e3)})),$("body").hasClass("mobiletheme")&&$('[data-toggle="tooltip"]').on("click",(function(){const $this=$(this);setTimeout((function(){$this.tooltip("hide")}),2e3)}))}}}));

//# sourceMappingURL=viewannotation.min.js.map